/***************************************************************************
                          gamer.cpp  -  description
                             -------------------
    begin                : Tue May 23 2000
    copyright            : (C) 2000 by Azarniy I.V.
    email                : azarniy@usa.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>

#include "prfconst.h"
#include "gamer.h"
#include "card.h"
#include "cardlist.h"
#include "coloda.h"
#include "ncounter.h"
#include "plscore.h"


//-------------------------------------------------------------------
TGamer::TGamer(int _nGamer) {
    nGamer = _nGamer;
    aScore = new TPlScore();
    aCards = new TCardList(12);  // 
    aLeft  = new TCardList(10);  //    (  )
    aRight = new TCardList(10);  //   (  )
    aOut   = new TCardList(2);   //  (  )
    aCardsOut = new TCardList(12);  //   
    aLeftOut  = new TCardList(12);  //      (  )
    aRightOut = new TCardList(12);  //     (  )
    set0();
}

//-------------------------------------------------------------------
TGamer::~TGamer() {
    delete aCards;
    delete aLeft;
    delete aRight;
    delete aOut;
    delete aCardsOut;
    delete aLeftOut;
    delete aRightOut;
    delete aScore;
}
//-----------------------------------------------------------------------
void TGamer::set0(void) {
  flMiser=0;
  aCards->RemoveAll();
  aLeft->RemoveAll();
  aRight->RemoveAll();
  aOut->RemoveAll();
  aCardsOut->RemoveAll();
  aLeftOut->RemoveAll();
  aRightOut->RemoveAll();
  Mast=withoutmast;
  GamesType=undefined;
  Enemy=noside;
  nGetsCard = 0;
  oldii = -1;
  for ( int i=0;i<=4;i++ )  {
    MastTable[i].vzatok=0;
    MastTable[i].perehvatov=0;
  }
  if (nGamer == 1) {
    nCardClosed = 0;
  } else {
    nCardClosed = 1;
  }
  Pronesti = NULL;

}
//-----------------------------------------------------------------------
void TGamer::AddCard(TCard *aCard) {
  aCards->Insert(aCard);
}
//-----------------------------------------------------------------------
void TGamer::AddCard(int _CName, int _CMast) {
  aCards->Insert(new TCard (_CName,_CMast));
}
//-----------------------------------------------------------------------
TCard *TGamer::Miser1(TGamer *aLeftGamer,TGamer *aRightGamer) {
    TCard *RetVal=NULL;
    if (aCards -> AllCard()==10) {	// first move    8..A   
    		for (int m=1;m<=4;m++) {
    			if (aCards->AllCard(m)==1) {
    				RetVal = aCards -> MinCard(m);
    				break;
    			}
    		} 		
    }
    if (!RetVal) {
    		for (int m=4;m>=1;m--) {
    			if (RetVal) break;
    			for (int c=A;c>=7;c--) {
	    			if (RetVal) break;
    				TCard *my;
    				//,*leftmax,*leftmin,*rightmax,*rightmin;
    				my = aCards->Exist(c,m);
    				if (my) {
    					int matrixindex=0;
    					matrixindex  += aLeftGamer -> aCards -> LessThan(my) ? 1:0; 	  matrixindex <<= 1;
    					matrixindex  += aLeftGamer -> aCards -> MoreThan(my) ? 1:0; 	matrixindex <<= 1;
    					matrixindex  += aRightGamer -> aCards -> LessThan(my) ? 1:0; 	matrixindex <<= 1;
    					matrixindex  += aRightGamer -> aCards -> MoreThan(my) ? 1:0;
    					if (matrixindex == 1 || matrixindex == 9 || matrixindex==13||(matrixindex >=4 && matrixindex <=7)) {
    						RetVal = my;
    					}
    				}
    			}
    		}
    }
		if (!RetVal) RetVal = aCards->MinCard(1);
		if (!RetVal) RetVal = aCards->MinCard(2);
		if (!RetVal) RetVal = aCards->MinCard(3);
		if (!RetVal) RetVal = aCards->MinCard(4);
    return RetVal;
}
//-----------------------------------------------------------------------
TCard *TGamer::Miser2(TCard *aRightCard,TGamer *aLeftGamer,TGamer *aRightGamer) {
    TCard *RetVal=NULL;
			if ( aCards->AllCard( aRightCard->CMast) ) {
    			for (int c=A;c>=7;c--) {
	    			if (RetVal) break;
    				TCard *my;
//,*leftmax,*leftmin,*rightmax,*rightmin;
    				my = aCards->Exist(c,aRightCard->CMast);
    				if (my) {
    					int matrixindex=0;
    					matrixindex  += aLeftGamer -> aCards -> LessThan(my) ? 1:0; 	matrixindex <<= 1;
    					matrixindex  += aLeftGamer -> aCards -> MoreThan(my) ? 1:0; 	matrixindex <<= 1;
    					matrixindex  += (*aRightCard < *my) ? 1:0; 	matrixindex <<= 1;
    					matrixindex  += (*aRightCard > *my) ? 1:0;
    					if (matrixindex == 1 || matrixindex == 9 || matrixindex==13||(matrixindex >=4 && matrixindex <=7)) {
    						RetVal = my;
    					}
    				}
    			}
    			if (!RetVal) RetVal = aCards->MaxCard(aRightCard->CMast);
    		} else {
				  TCardList *aMaxCardList=new TCardList(20);
			    LoadLists(aRightGamer,aLeftGamer,aMaxCardList);
		       RetVal = GetMaxCardWithOutPere();
    			   if ( !RetVal ) {
               RetVal = GetMaxCardPere();  //   (max)
			     }
      			 if ( !RetVal ) {
             RetVal = GetMinCardWithOutVz(); // 
		       }
    			   if ( !RetVal ) {
              RetVal = aCards->MaxCard();
       		}			
			    delete aMaxCardList;    		
    		}
    return RetVal;
}
//-----------------------------------------------------------------------
TCard *TGamer::Miser3(TCard *aLeftCard,TCard *aRightCard,TGamer *aLeftGamer,TGamer *aRightGamer) {
// copy from MyPass3
  TCard *RetVal=NULL;
    /*TCard *MaxCard;*/
    TGamesType tmpGamesType=GamesType;
    TCardList *aMaxCardList=new TCardList(20);
//    int mast = GamesType - (GamesType/10) * 10;
    //  
    LoadLists(aLeftGamer,aRightGamer,aMaxCardList);
    RecountTables4RasPass(aMaxCardList,23);
    if ( aCards->AllCard(aLeftCard->CMast) )  {
       //         
       //  
       if (aLeftCard->CMast == aRightCard ->CMast) {
       	if (*aRightCard > *aLeftCard) {
       		RetVal = aCards -> LessThan(aRightCard);      		
       	} else {
       		RetVal = aCards -> LessThan(aLeftCard);
       	}
       } else {
	       RetVal = aCards -> LessThan(aLeftCard);
	     }
       if ( !RetVal  ) {
           RetVal = aCards ->MaxCard(aLeftCard->CMast);
       }
    } else {
      //         
       RetVal = GetMaxCardWithOutPere();
       if ( !RetVal ) {
               RetVal = GetMaxCardPere();  //   (max)
       }
       if ( !RetVal ) {
             RetVal = GetMinCardWithOutVz(); // 
       }
       if ( !RetVal ) {
              RetVal = aCards->MinCard();
       }

    }
    GamesType=tmpGamesType;
    delete aMaxCardList;
  return RetVal;
}
//-----------------------------------------------------------------------
TCard *TGamer::makemove(TCard *lMove,TCard *rMove,TGamer *aLeftGamer,TGamer *aRightGamer) { //
    TCard *RetVal=NULL;
    if (lMove == NULL && rMove == NULL) { //   - 
        if ( GamesType == pass || GamesType == vist ) {
              // -      
              RetVal = MyVist1(aLeftGamer,aRightGamer);
        } else 	if (GamesType == g86catch) {
       			RetVal = MiserCatch1(aLeftGamer,aRightGamer);
    			} else	if (GamesType == g86) {
     			RetVal = Miser1(aLeftGamer,aRightGamer);
    			} else   if (  GamesType == raspass  ) {
            RetVal = MyPass1(rMove,aLeftGamer,aRightGamer);; //     
        } else {
            //    
            RetVal = MyGame1(aLeftGamer,aRightGamer);
        }

    }
    if (lMove == NULL && rMove != NULL) { //   - 
        if ( GamesType == pass || GamesType == vist ) {
                // -      
                RetVal = MyVist2(rMove,aLeftGamer,aRightGamer);
        } else if (GamesType == g86catch) {
	        			RetVal = MiserCatch2(rMove,aLeftGamer,aRightGamer);
   			} else if (GamesType == g86) {
        			RetVal = Miser2(rMove,aLeftGamer,aRightGamer);
    			} else  if ( GamesType == raspass  ) {
                RetVal = MyPass2(rMove,aLeftGamer,aRightGamer); //     
        } else {   //    
            RetVal = MyGame2(rMove,aLeftGamer,aRightGamer);

		}

    }
    if (lMove != NULL && rMove != NULL) { //   - 3
        if ( GamesType == pass || GamesType == vist ) {
                // -      
           RetVal = MyVist3(lMove,rMove,aLeftGamer,aRightGamer);
        } else if (GamesType == g86catch) {
      			RetVal = MiserCatch3(lMove,rMove,aLeftGamer,aRightGamer);
    			} else	if (GamesType == g86) {
      			RetVal = Miser3(lMove,rMove,aLeftGamer,aRightGamer);
    			} else if ( GamesType == raspass ) {
           RetVal = MyPass3(lMove,rMove,aLeftGamer,aRightGamer);; //     
        } else {
           //    
           RetVal = MyGame3(lMove,rMove,aLeftGamer,aRightGamer);
        }
    }
    aCards    -> Remove(RetVal);
    aCardsOut -> Insert(RetVal);

    return RetVal;
}
//-----------------------------------------------------------------------
TMastTable TGamer::vzatok(TMast Mast,TCardList *aMaxCardList,int a23) {
   TMastTable MastTable;
   TCard *MyCard,*tmpCard;
   TCardList *MyCardStack     = new TCardList(MAXMASTLEN);
   TCardList *EnemyCardStack  = new TCardList(MAXMASTLEN);
   for (int c=7;c<=A;c++ ) {
        MyCard = aCards->Exist(c, Mast);
        if ( MyCard ) {
          MyCardStack->Insert(MyCard);
        }
        MyCard = aMaxCardList->Exist(c, Mast);
        if ( MyCard ) {
          EnemyCardStack->Insert(MyCard);
        }
   }
   if (a23 != 23) {
       MastTable = Compare2List4Max(MyCardStack,EnemyCardStack);
   } else {
       MastTable = Compare2List4Max23(MyCardStack,EnemyCardStack);
   }
   MastTable.len = aCards->AllCard(Mast);
   MastTable.sum = 0;
   for (int j=7;j<=A;j++ ) {
    tmpCard = aCards->Exist(j,Mast);
    if (  tmpCard ) {
      MastTable.sum +=  tmpCard -> CName;
    }
   }
   MyCardStack -> RemoveAll();
   EnemyCardStack-> RemoveAll();
   delete MyCardStack;
   delete EnemyCardStack;
   return MastTable;
}
//-----------------------------------------------------------------------
void TGamer::RecountTables4RasPass(TCardList *aMaxCardList,int a23) { //      
    int i;
    MastTable[0].vzatok=0;
    MastTable[0].perehvatov=0;
    MastTable[0].sum=0;
    for (i=1; i<=4; i++ )  {
      MastTable[i] = vzatok4pass( (TMast) i,aMaxCardList );
      MastTable[0].vzatok += MastTable[i].vzatok ;
      MastTable[0].perehvatov += MastTable[i].perehvatov ;
      MastTable[0].sum += MastTable[i].sum;
    }

}
//-----------------------------------------------------------------------
void TGamer::RecountTables( TCardList *aMaxCardList,int a23 ){ //           TMastTable MastTable[5];
    int i;
    MastTable[0].vzatok=0;
    MastTable[0].perehvatov=0;
    MastTable[0].sum=0;
    for (i=1; i<=4; i++ )  {
      MastTable[i] = vzatok ( (TMast) i,aMaxCardList, a23 );
      MastTable[0].vzatok += MastTable[i].vzatok ;
      MastTable[0].perehvatov += MastTable[i].perehvatov ;
      MastTable[0].sum += MastTable[i].sum;
    }
}
//-----------------------------------------------------------------------
TCard *TGamer::MiserCatch1(TGamer *aLeftGamer,TGamer *aRightGamer) {
  TCard *RetVal=NULL;
  TCardList *aMaxCardList=new TCardList(20);
  TCardList *Naparnik;
  TSide Side ;
  if (aRightGamer->GamesType == g86) {
    LoadLists(aRightGamer,aRightGamer,aMaxCardList);
    Naparnik = aLeftGamer -> aCards;
    Side = right;
  } else {
    LoadLists(aLeftGamer,aLeftGamer,aMaxCardList);
    Naparnik = aRightGamer -> aCards;
    Side = left;
  }
  RecountTables4RasPass(aMaxCardList,1);
//  if (Side == left) {
// 1.  
		for (int m=1;m<=4;m++) {	
			TCard *EnemyMin = aMaxCardList -> MinCard(m);
			TCard *NaparnikMin = Naparnik -> MinCard(m);			
			TCard *MyMin = aCards -> MinCard(m);
			if (RetVal)
				goto badlabel;
			if (EnemyMin) { // 
				if (MyMin) { //     
					if (NaparnikMin) { //     
						if ( *NaparnikMin < *EnemyMin && *MyMin < *EnemyMin) {
							RetVal = MyMin;// 
							goto badlabel;
						}
						if ( *NaparnikMin > *EnemyMin && *MyMin < *EnemyMin) {
							//  -        
							//     
							for (int k=1;k<=4;k++)	{
								if (k==m || aMaxCardList->AllCard(k)==0)
									continue;
								TCard *EnemyMax = aMaxCardList -> MaxCard(k);
								TCard *NaparnikMax = Naparnik -> MaxCard(k);			
								TCard *MyMax = aCards -> MaxCard(k);
								if ( MyMax && NaparnikMax && EnemyMax) {
									if (Naparnik->AllCard(k) < aCards-> AllCard(k) && Naparnik->AllCard(k) < aMaxCardList->AllCard(k) ) {
										RetVal = aCards ->LessThan(EnemyMax);		
//										MyMax; //      NaparnikMax
									  if (aRightGamer->GamesType == g86) {
									  		aRightGamer -> Pronesti = NaparnikMax;
									  	} 	else {
									  		aLeftGamer -> Pronesti = NaparnikMax;
									  	}
									  	goto badlabel;
									}
								}
							}
						}
					} else { //   
						if (*MyMin < *EnemyMin) {
							RetVal = MyMin;// 						
							goto badlabel;
						}
					}
				}
			}
		}
		

//		2  
		if (!RetVal) RetVal = GetMaxCardWithOutPere();
		if (Side == left) {
			//       !!!
		}
// 3 		
		if (!RetVal) RetVal = GetMaxCardWithOutPere();
		if (!RetVal) RetVal = aCards->MinCard();	
//  } else { //Side == left
//  }
badlabel:

	aMaxCardList->RemoveAll();
	delete aMaxCardList;
  return RetVal;
}
//-----------------------------------------------------------------------
TCard *TGamer::MiserCatch2(TCard *aRightCard,TGamer *aLeftGamer,TGamer *aRightGamer) {
  TCard *RetVal=NULL;
  TCardList *aMaxCardList=new TCardList(20);
  TCardList *Naparnik;
  TSide Side ;
  if (aRightGamer->GamesType == g86) {
    LoadLists(aRightGamer,aRightGamer,aMaxCardList);
    Naparnik = aLeftGamer -> aCards;
    Side = right;
  } else {
    LoadLists(aLeftGamer,aLeftGamer,aMaxCardList);
    Naparnik = aRightGamer -> aCards;
    Side = left;
  }
  RecountTables4RasPass(aMaxCardList,23);

  if (Side == left) { //   ,   
  		if (aCards->AllCard(aRightCard->CMast)) {
  			//        
  			TCard *MyMax = aCards->MaxCard(aRightCard->CMast);
  			TCard *MyMin = aCards->MinCard(aRightCard->CMast);
//  			TCard *EnMax = aMaxCardList->MaxCard(aRightCard->CMast);
  			TCard *EnMin = aMaxCardList->MinCard(aRightCard->CMast);
  			if (EnMin) {
  				//       
  				if (*aRightCard < *EnMin) {
  					//   
  					RetVal=aCards->LessThan(EnMin);
  					if(!RetVal) RetVal = aCards -> MoreThan(EnMin);
  				} else {
					RetVal= aCards -> MoreThan(EnMin);
  				}
  			} else {
  				RetVal = MyMax; //        	
  			}
  			
  		} else {




  			//          		
	  		if (Pronesti) {
	  			//  
	  			if (aCards->Exist(Pronesti->CName,Pronesti->CMast)) {
  					RetVal = Pronesti;  				  			
  				} else {
  					RetVal = aCards -> MaxCard(Pronesti->CMast);
  					if (!RetVal)   RetVal = aCards -> MaxCard();
  				}  		
  			} else {
  				//    - 
  				RetVal = GetMaxCardPere();
				if (!RetVal) RetVal = aCards -> MaxCard();  				
  			}  			
  		}
  } else { //    
		TCard *MyMax = aCards->MaxCard(aRightCard->CMast);
		TCard *MyMin = aCards->MinCard(aRightCard->CMast);
		if (MyMax) {

			if ( *MyMin < *aRightCard) {
//				  
				TCard *NapMin = Naparnik->LessThan(aRightCard);
				if (NapMin) {
					RetVal = aCards->LessThan(aRightCard);					
				} else {
					RetVal = MyMax; //    ?
				}
			} else {
				RetVal = MyMax; //    
			}
			
		} else {
			//     

  				RetVal = GetMaxCardPere();
				if (!RetVal) RetVal = aCards -> MaxCard();  				
		}

  }
	Pronesti = NULL;
	if (!RetVal)
		RetVal = aCards -> MinCard();

	aMaxCardList->RemoveAll();
	delete aMaxCardList;
  return RetVal;

}
//-----------------------------------------------------------------------
TCard *TGamer::MiserCatch3(TCard *aLeftCard,TCard *aRightCard,TGamer *aLeftGamer,TGamer *aRightGamer) {
  TCard *RetVal=NULL;
  TCardList *aMaxCardList=new TCardList(20);
  TCardList *Naparnik;
  TSide Side ;
  if (aRightGamer->GamesType == g86) {
    LoadLists(aRightGamer,aRightGamer,aMaxCardList);
    Naparnik = aLeftGamer -> aCards;
    Side = right;
  } else {
    LoadLists(aLeftGamer,aLeftGamer,aMaxCardList);
    Naparnik = aRightGamer -> aCards;
    Side = left;
  }
  RecountTables4RasPass(aMaxCardList,23);

  if (Side == left) {
  		if (aCards->AllCard(aLeftCard->CMast)) {
  			//        
//  			TCard *MyMax = aCards->MaxCard(aLeftCard->CMast);
//  			TCard *MyMin = aCards->MinCard(aLeftCard->CMast);
  			if (*aLeftCard < *aRightCard) {
  				//    
  				RetVal = aCards -> MaxCard(aLeftCard->CMast);
  				
  			} else {
  				//  
  				RetVal = aCards -> LessThan(aLeftCard);
  				if (!RetVal ) RetVal = aCards -> MaxCard(aLeftCard->CMast);				
  			}
  		} else {
  			//          		
	  		if (Pronesti) {
	  			//  
	  			if (aCards->Exist(Pronesti->CName,Pronesti->CMast)) {
  					RetVal = Pronesti;  				  			
  				} else {
  					RetVal = aCards -> MaxCard(Pronesti->CMast);
  					if (!RetVal) RetVal = aCards -> MaxCard();
  				}  		
  			} else {
  				//    - 
  				RetVal = GetMaxCardPere();
				if (!RetVal) RetVal = aCards -> MaxCard();  				
  			}  			
  		}
  } else { // right - my friend
		TCard *MyMax = aCards->MaxCard(aLeftCard->CMast);
		TCard *MyMin = aCards->MinCard(aLeftCard->CMast);
		if (MyMax) {
			if ( *MyMin < *aLeftCard) {
//				  
				TCard *NapMin = Naparnik->LessThan(aLeftCard);
				if (NapMin) {
					RetVal = aCards->LessThan(aLeftCard);					
				} else {
					RetVal = MyMax; //    ?
				}
			} else {
				RetVal = MyMax; //    
			}
			
		} else {
			//     
  				RetVal = GetMaxCardPere();
				if (!RetVal) RetVal = aCards -> MaxCard();  				
		}

  }
	Pronesti = NULL;

	aMaxCardList->RemoveAll();
	delete aMaxCardList;
  return RetVal;
}
//-----------------------------------------------------------------------
TCard *TGamer::MyGame3(TCard *aLeftCard,TCard *aRightCard,TGamer *aLeftGamer,TGamer *aRightGamer) { //   3  - 
    TCard *RetVal=NULL;
    TCard *MaxCard;
    TGamesType tmpGamesType=GamesType;
    TCardList *aMaxCardList=new TCardList(20);
    int mast = GamesType - (GamesType/10) * 10;
    //  
    LoadLists(aLeftGamer,aRightGamer,aMaxCardList);
    RecountTables(aMaxCardList,23);
    if ( aCards->AllCard(aLeftCard->CMast) )  {
       //         
        if ( aLeftCard->CMast == aRightCard->CMast)  {
            //  
            RetVal = aCards -> MoreThan(aLeftCard);
            if ( !RetVal  ) {
               RetVal = aCards ->MinCard(aLeftCard->CMast);
            }
        } else { //aLeftCard->CMast == aRightCard->CMast
          if ( aRightCard->CMast !=mast)  {
            //   

            RetVal = aCards -> MoreThan(aLeftCard);
            if ( !RetVal ) {
              RetVal = aCards -> MinCard(aLeftCard->CMast);
            }
          } else {
            //  ,    
            RetVal = aCards -> MinCard(aLeftCard->CMast);
          }
        }
    } else {
      //         
       if (aLeftCard->CMast==aRightCard->CMast) {
           if ( *aLeftCard > *aRightCard ) {
               MaxCard = aLeftCard;
           } else {
               MaxCard = aLeftCard;
           }
       } else {
           if ( aLeftCard->CMast != mast && aRightCard->CMast != mast) {
               MaxCard = aLeftCard;
           } else {
               MaxCard = aRightCard;
           }
       }
       RetVal = aCards -> MoreThan(MaxCard);
       if (!RetVal) {
           RetVal = aCards -> MinCard(mast);
       }
       if ( ! RetVal ) { //  .
           RetVal = GetMinCardWithOutVz();
       }
       if ( ! RetVal ) {
           RetVal = aCards -> MinCard();
       }
    }

    GamesType=tmpGamesType;
    delete aMaxCardList;
    return RetVal;

}
//-----------------------------------------------------------------------
TCard *TGamer::MyVist3(TCard *aLeftCard,TCard *aRightCard,TGamer *aLeftGamer,TGamer *aRightGamer) { //     3  - 
    TCard *RetVal=NULL;
    TCard *MaxCard;
    TGamesType tmpGamesType=GamesType;
    TCardList *aMaxCardList=new TCardList(20);
    TGamer *aEnemy,*aFriend;
    int mast;
    //     
    if ( aLeftGamer -> GamesType != pass && aLeftGamer -> GamesType != vist ) {
        aEnemy = aLeftGamer;
        aFriend = aRightGamer;
    } else {
        aEnemy = aRightGamer;
        aFriend = aLeftGamer;
    }
    mast = aEnemy->GamesType - (aEnemy->GamesType/10) * 10;
    //  
//    LoadLists(aLeftGamer,aRightGamer,aMaxCardList);
//    RecountTables(aMaxCardList,23);
    if ( aCards->AllCard(aLeftCard->CMast) )  {
       //         
      if ( aEnemy == aLeftGamer ) { //  - 
		    LoadLists(aLeftGamer,aLeftGamer,aMaxCardList);
		    RecountTables(aMaxCardList,23);

        if ( aLeftCard->CMast == aRightCard->CMast)  {
          if ( *aRightCard > *aLeftCard ) {
            //   
            RetVal = aCards->MinCard(aRightCard->CMast);
          } else {
            //  
            RetVal = aCards -> MoreThan(aLeftCard);
            if ( !RetVal  ) {
               RetVal = aCards ->MinCard(aLeftCard->CMast);
            }
          }
        } else { //aLeftCard->CMast == aRightCard->CMast
          if ( aRightCard->CMast !=mast)  {
            //   
            RetVal = aCards -> MoreThan(aLeftCard);
            if ( !RetVal ) {
              RetVal = aCards -> MinCard(aLeftCard->CMast);
            }
          } else {
            //  ,    
            RetVal = aCards -> MinCard(aLeftCard->CMast);
          }
        }

      } else {
        // 
		    LoadLists(aRightGamer,aRightGamer,aMaxCardList);
		    RecountTables(aMaxCardList,23);
        if ( aLeftCard->CMast == aRightCard->CMast  )  {
          if ( *aRightCard > *aLeftCard ) {
            //   
            RetVal = aCards->MoreThan(aRightCard);
            if ( !RetVal ) {
              RetVal = aCards->MinCard(aRightCard->CMast);
            }
          } else {
            //   
            RetVal = aCards->MinCard(aRightCard->CMast);
          }
        } else {
          if ( aRightCard->CMast==mast  ) {
            //  ,    
            RetVal = aCards->MinCard(aLeftCard->CMast);
          } else { //   ....        !!!
            RetVal = aCards->MinCard(aLeftCard->CMast);
          }
        }

      }
    } else {
      //         
       if (aLeftCard->CMast==aRightCard->CMast) {
           if ( *aLeftCard > *aRightCard ) {   MaxCard = aLeftCard;
           } else { MaxCard = aLeftCard; }
       } else {
           if ( aLeftCard->CMast != mast && aRightCard->CMast != mast) {               MaxCard = aLeftCard;
           } else { MaxCard = aRightCard;
           }
       }
       if ( aEnemy == aLeftGamer ) { //   
    		    LoadLists(aLeftGamer,aLeftGamer,aMaxCardList);

			    RecountTables(aMaxCardList,23);

           if (MaxCard == aLeftCard ) { //   
               RetVal = aCards -> MoreThan(aLeftCard);
           } else { //   ...  
               RetVal = aCards -> MinCard(MaxCard->CMast);
           }
       } else { //   - 
			    LoadLists(aRightGamer,aRightGamer,aMaxCardList);
			    RecountTables(aMaxCardList,23);

           if (MaxCard == aLeftCard ) { //   ...  
               RetVal = aCards -> MinCard(MaxCard->CMast);
           } else { //   
               RetVal = aCards -> MoreThan(aLeftCard);
           }
       }
       if (!RetVal) {
           RetVal = aCards -> MinCard(mast);
       }
       if ( ! RetVal ) { //  .
           RetVal = GetMinCardWithOutVz();
       }
       if ( ! RetVal ) {
           RetVal = aCards -> MinCard();
       }


    }

    GamesType=tmpGamesType;
    delete aMaxCardList;
    return RetVal;

}
//-----------------------------------------------------------------------

TCard *TGamer::MyVist2(TCard *aRightCard,TGamer *aLeftGamer,TGamer *aRightGamer) { //     2  - 
    TCard *RetVal=NULL;
    TGamesType tmpGamesType=GamesType;
    TCardList *aMaxCardList=new TCardList(20);
    TGamer *aEnemy,*aFriend;
    int mast;
    //     
    if ( aLeftGamer -> GamesType != pass && aLeftGamer -> GamesType != vist ) {
        aEnemy = aLeftGamer;
        aFriend = aRightGamer;
    } else {
        aEnemy = aRightGamer;
        aFriend = aLeftGamer;
    }
    mast = aEnemy->GamesType - (aEnemy->GamesType/10) * 10;
    //  
    if ( aEnemy == aLeftGamer ) { //   
		    LoadLists(aLeftGamer,aLeftGamer,aMaxCardList);
		    RecountTables(aMaxCardList,23);
        //        
        if ( aRightCard -> CName >= 10 ) {
            RetVal = aCards -> MinCard(aRightCard -> CMast);
        } else { //              
            RetVal = aCards -> MaxCard(aRightCard -> CMast);
        }
        if ( !RetVal ) { //       !!!
            RetVal = aCards -> MaxCard(mast); //  
        }
        if ( ! RetVal ) {
            RetVal = GetMinCardWithOutVz();
        }
    } else { //   - 
		    LoadLists(aRightGamer,aRightGamer,aMaxCardList);
		    RecountTables(aMaxCardList,23);
        RetVal = aCards->MoreThan(aRightCard);
        if (!RetVal) {
            RetVal = aCards->MinCard(aRightCard->CMast);
        }
        if (!RetVal) { //    
            RetVal = aCards->MinCard(mast);
        }
        if (!RetVal) { //    
            RetVal = GetMinCardWithOutVz();
        }
    }
    GamesType=tmpGamesType;
    delete aMaxCardList;
    return RetVal;

}
//-----------------------------------------------------------------------
TCard *TGamer::MyVist1(TGamer *aLeftGamer,TGamer *aRightGamer) {
// 1 -   2-    3-  4-???
    TCard *RetVal=NULL;
    TGamesType tmpGamesType=GamesType;
    TCardList *aMaxCardList=new TCardList(20);
    TGamer *aEnemy,*aFriend;
    int mast;
    //     
    if ( aLeftGamer -> GamesType != pass && aLeftGamer -> GamesType != vist ) {
        aEnemy = aLeftGamer;
        aFriend = aRightGamer;
    } else {
        aEnemy = aRightGamer;
        aFriend = aLeftGamer;

    }
    mast = aEnemy->GamesType - (aEnemy->GamesType/10) * 10;
    //  
//    LoadLists(aLeftGamer,aRightGamer,aMaxCardList);
//    RecountTables(aMaxCardList,1);
    if ( aEnemy == aLeftGamer ) { //   
	  		  LoadLists(aLeftGamer,aLeftGamer,aMaxCardList);
  		  		RecountTables(aMaxCardList,1);
  		  		if ( aLeftGamer ->aCards ->AllCard(mast) <=2  ) {
					TCard *m =aCards ->MaxCard(mast);
					if (!m) {
	  		  			RetVal = aCards ->MinCard(aLeftGamer ->aCards ->EmptyMast (mast));
	  		  		} else {
	  		  			if (aLeftGamer ->aCards ->MaxCard(mast)->CName < m->CName) {
	  		  				RetVal = aCards -> MaxCard(mast);	  		  			
	  		  			} else {
		  		  			RetVal = aCards ->MinCard(aLeftGamer ->aCards ->EmptyMast (mast));	  		  			
	  		  			}  		  		
	  		  		}
  		  		} else {
		  		  			RetVal = aCards ->MinCard(aLeftGamer ->aCards ->EmptyMast (mast));  		  		
  		  		}
        if ( !RetVal) {
	        RetVal = GetMinCardWithOutVz();
	      }

/*        if ( aCards -> Exist(A,RetVal->CMast) || aCards -> Exist(K,RetVal->CMast) ) {
		      RetVal = NULL;
        		RetVal = aCards ->MinCard(aMaxCardList ->EmptyMast (0));
        }*/


        if ( !RetVal) {
            RetVal = GetMaxCardWithOutPere();
        }
        if ( !RetVal) {
            RetVal = aCards -> MinCard(mast);
        }
        if ( !RetVal) {
            RetVal = GetMaxCardPere();
        }
    } else { //   - 
		    LoadLists(aRightGamer,aRightGamer,aMaxCardList);
  			  RecountTables(aMaxCardList,1);

        RetVal = GetMaxCardWithOutPere();
        if ( !RetVal) {
            RetVal = GetMaxCardPere();
        }
        if ( !RetVal) {
            RetVal = aCards -> MaxCard();
        }
    }
    GamesType=tmpGamesType;
    delete aMaxCardList;
    return RetVal;
}

//-----------------------------------------------------------------------
TCard *TGamer::MyGame2(TCard *aRightCard,TGamer *aLeftGamer,TGamer *aRightGamer) {
    TCardList *aMaxCardList=new TCardList(20);
    TGamesType tmpGamesType=GamesType;
    TCard *RetVal=NULL;
    TCard *MaxLeftCard=NULL;
    int mast = aRightCard -> CMast;
    int koz  = GamesType - (GamesType/10) * 10;
    //  
    LoadLists(aLeftGamer,aRightGamer,aMaxCardList);
    RecountTables(aMaxCardList,23);

    RetVal = aCards -> MaxCard(mast);
    if ( !RetVal ) { //  
        if ( !aLeftGamer -> aCards -> AllCard(mast) ) { //    
            MaxLeftCard = aLeftGamer -> aCards ->MaxCard(koz);
            RetVal = aCards -> MoreThan(MaxLeftCard); //
            if (!RetVal) {
                RetVal = aCards -> LessThan(MaxLeftCard);
            }
            if ( !RetVal ) {
                RetVal = GetMinCardWithOutVz(); // 
            }
            if ( !RetVal ) {
                 RetVal = aCards->MinCard();
            }

        } else { //    

			RetVal = aCards -> MinCard(koz);


			// --------- () feal 2.11.2003 -------------
			if ( !RetVal ) //  ړ
				RetVal = aCards -> MinCard();
			// ------------------------------------------

        }
    } else { //    
        if ( aLeftGamer -> aCards -> AllCard(mast) ) { //  
            MaxLeftCard = aLeftGamer -> aCards ->MaxCard(mast);
            RetVal = aCards -> MoreThan(MaxLeftCard);
            if ( !RetVal ) {
                RetVal = aCards -> LessThan(MaxLeftCard);
            }
        } else { //   
            if ( !aLeftGamer -> aCards -> AllCard(koz) ) { //    
                RetVal = aCards -> MoreThan(aRightCard);
                if ( !RetVal) {
                    RetVal = aCards -> MinCard(mast);
                }
            } else { //    
                RetVal = aCards -> MinCard(mast);
            }
        }
    }


    GamesType=tmpGamesType;
    delete aMaxCardList;
    return RetVal;
}
//-----------------------------------------------------------------------
TCard *TGamer::MyGame1(TGamer *aLeftGamer,TGamer *aRightGamer) {
// 1-  2-    3-  4-???
    TCard *RetVal=NULL;
    TGamesType tmpGamesType=GamesType;
    TCardList *aMaxCardList=new TCardList(20);
    int mast = GamesType - (GamesType/10) * 10;
    //  
    LoadLists(aLeftGamer,aRightGamer,aMaxCardList);
    RecountTables(aMaxCardList,1);
    if ( aLeft->AllCard(mast) || aRight->AllCard(mast) ) { //    
        RetVal = aCards->MaxCard(mast);
        if ( !RetVal ) { //      !!!
             RetVal = GetMaxCardWithOutPere(); //  
        }
        if ( !RetVal ) {
             RetVal = GetMaxCardPere();  //   (max)
        }
        if ( !RetVal ) {
             RetVal = GetMinCardWithOutVz(); // 
        }
        if ( !RetVal ) {
             RetVal = aCards->MaxCard();
        }
    } else { //       !!!
        if ( !RetVal ) {
             RetVal = GetMaxCardPere();  //   (max)
        }
        if ( !RetVal ) { //      !!!
             RetVal = GetMaxCardWithOutPere(); //  
        }
        if ( !RetVal ) {
             RetVal = GetMinCardWithOutVz(); // 
        }
        if ( !RetVal ) {
            RetVal = aCards->MaxCard(mast);
        }
        if ( !RetVal ) {
             RetVal = aCards->MaxCard();
        }
    }


    GamesType=tmpGamesType;
    delete aMaxCardList;
    return RetVal;
}
//-----------------------------------------------------------------------
TCard *TGamer::GetMaxCardPere(void) {
    int index=0,vz=0,pere=0;

    for (int i=1;i<=4;i++) {
        if ( MastTable[i].vzatok > vz || (MastTable[i].vzatok == vz && MastTable[i].perehvatov > pere) ) {
            index = i;
            vz = MastTable[i].vzatok;
            pere = MastTable[i].perehvatov;
        }
    }

    if (index) return aCards->MaxCard(index);
    return NULL;
}
//-----------------------------------------------------------------------
TCard *TGamer::GetMaxCardWithOutPere(void) {
    int index=0,vz=0,pere=0;
    for (int i=1;i<=4;i++) {
        if ( MastTable[i].vzatok > vz || (MastTable[i].vzatok == vz && MastTable[i].perehvatov < pere) ) {
            index = i;
            vz = MastTable[i].vzatok;
            pere = MastTable[i].perehvatov;
        }
    }
    if (index) return aCards->MaxCard(index);
    return NULL;
}
//-----------------------------------------------------------------------
TCard *TGamer::GetMinCardWithOutVz(void) {
    int index=0;
    //,vz=8;
    float koef = 0,koef1 = 0 ;
    for (int i=1;i<=4;i++) {
    		koef1 = float ( MastTable[i].len+ 8/(1+MastTable  [i].vzatok) );
    		if ( (koef1 > koef && MastTable[i].len!=0) || (MastTable  [i].vzatok == 0 && MastTable[i].len > 0)) {
    			index = i;
    			koef =koef1;
    		}    		
    }
    if (index && index <=4)
    		return aCards->MinCard(index);
    	else
    		return aCards->MinCard();
//    return NULL;
}
//-----------------------------------------------------------------------
void TGamer::LoadLists(TGamer *aLeftGamer,TGamer *aRightGamer,TCardList *aMaxCardList) {
/*    int nLeftVisible = aLeftGamer -> nCardsVisible,nRightVisible = aRightGamer -> nCardsVisible;
    int nCards = aCards -> AllCard();       */
    aLeft  -> RemoveAll();
    aRight -> RemoveAll();
/*    // !!!!!!!!!!!!!!!!!!!!!!!!!  ,   
    if ( !nLeftVisible && !nRightVisible ) {
        makestatfill(nCards,1); // ,1- for max list 2- for minlist
    }
    if ( nLeftVisible && !nRightVisible ) {
        makestatfill(nCards,1); // ,1- for max list 2- for minlist
    }
    if ( !nLeftVisible && nRightVisible ) {
        makestatfill(nCards,1); // ,1- for max list 2- for minlist
    }
    if ( nLeftVisible && nRightVisible ) {*/
        aLeft -> Assign(aLeftGamer -> aCards);
        aRight -> Assign(aRightGamer -> aCards);
/*    }*/
// Get Max List only len
/*    for (int m=1;m<=4;m++) {
      for (int c=A;c>=7;c-- ) {
       if ( aLeft -> Exist(c,m) || aRight -> Exist(c,m) ) {
           aMaxCardList->Insert(new TCard(c,m));
       }
      }
    }*/
    for (int m=1;m<=4;m++) {
      		TCard *LeftMax,*RightMax,*Max=NULL;	
      		while ( aLeft ->AllCard(m) || aRight ->AllCard(m)) {
      			LeftMax = aLeft -> MaxCard(m);
      			RightMax=aRight-> MaxCard(m);
      			if (LeftMax == NULL && RightMax== NULL) {
      				Max=NULL;
      			} else if (LeftMax == NULL && RightMax!= NULL) {
      				Max = RightMax;
      				aRight -> Remove(Max);
      			} else if (LeftMax != NULL && RightMax== NULL) {
      				Max = LeftMax ;
      				aLeft ->Remove(Max);
      			} else if  ( *LeftMax > *RightMax ) {
      				Max = LeftMax;
      				aLeft ->Remove(LeftMax);
      				aRight -> Remove(RightMax);
      			} else {
      				Max = RightMax;
      				aLeft ->Remove(LeftMax);
      				aRight -> Remove(RightMax);      				
      			}   			
      		}
      		if (Max !=NULL) {
      			aMaxCardList->Insert(new TCard(Max->CName,Max->CMast));
      		}     		
    }
    aLeft  -> RemoveAll();
    aRight -> RemoveAll();
    aLeft -> Assign(aLeftGamer -> aCards);
    aRight -> Assign(aRightGamer -> aCards);
}
//-----------------------------------------------------------------------
TGamesType TGamer::makemove4out(void) {
    TGamesType GamesTypeRetVal;
    int i;
    int nMaxMastLen=0;
    TMast nMaxMast=withoutmast;
    TMastTable LocalMastTable[5];
    LocalMastTable[0].vzatok=0;
    LocalMastTable[0].perehvatov=0;
    LocalMastTable[0].sum=0;


    for (i=1; i<=4; i++ )  {
      LocalMastTable[i] = vzatok4game( (TMast) i,1  );
      LocalMastTable[0].vzatok += LocalMastTable[i].vzatok ;
      LocalMastTable[0].perehvatov +=LocalMastTable[i].perehvatov ;
      LocalMastTable[0].sum += LocalMastTable[i].sum;
    }

    for (i=1; i<=4; i++) { //   -   
      if( aCards->AllCard(i) > nMaxMastLen ) {
        nMaxMastLen = aCards->AllCard(i);
        nMaxMast = (TMast) i;
      }
    }

    for (i=1; i<=4; i++) {
      if(aCards->AllCard(i) == nMaxMastLen && nMaxMast != i ) { //    
       if ( LocalMastTable[i].sum  > LocalMastTable[nMaxMast].sum  )  {
         nMaxMast = (TMast) i;
        }
      }
    }

    //    
    GamesTypeRetVal = ( TGamesType ) (LocalMastTable[0].vzatok*10 + nMaxMast );
    //  ,     
    return GamesTypeRetVal;

}
//-----------------------------------------------------------------------
TGamesType TGamer::makemove(TGamesType MaxGame,int HaveAVist,int nGamerVist) { //     -   
  TGamesType Answer;
  TGamesType MyMaxGame = makemove4out();

  int vz = MyMaxGame / 10;
  if ( HaveAVist != vist && vz >= nGetMinCard4Vist(MaxGame) ) {
     Answer = vist;
  } else {
     Answer = pass;
  }
  if ( HaveAVist==pass && vz < nGetMinCard4Vist(MaxGame) ) {
     Answer = pass;
  }
  if (MaxGame == g61) {
     Answer = vist; //STALINGRAD !!!
  }
  if (MaxGame == g86) { // miser
     Answer = g86catch;
  }
  GamesType = Answer;
  return Answer;
}
//-----------------------------------------------------------------------
TGamesType TGamer::makeout4miser(void) {
  TCard *FirstCardOut=NULL,*SecondCardOut=NULL;
  TCard *tmpFirstCardOut,*tmpSecondCardOut;
  TCard *RealFirstCardOut,*RealSecondCardOut;
  TGamesType  Hight = g105,  tmpHight = g105;
  for ( int i=0;i<12;i++ ) {
    tmpFirstCardOut = (TCard*) aCards -> At(i);
    aCards -> AtRemove(i);
    for ( int j=0;j<12;j++ )  {

      if ( j!=i ) {
        tmpSecondCardOut = (TCard*) aCards -> At(j);
        aCards -> AtRemove(j);
        TGamer *tmpGamer = new TGamer(99);
        tmpGamer -> aCards -> Assign(aCards);
        tmpGamer -> aCards -> mySort();
        tmpHight = tmpGamer -> makemove4out();
        if ( (tmpHight < Hight )
         || (tmpHight == Hight  && tmpGamer->MastTable[0].perehvatov < MastTable[0].perehvatov) ) {
          Hight = tmpHight;
          FirstCardOut = tmpFirstCardOut;
          SecondCardOut = tmpSecondCardOut;
        }
        tmpGamer -> aCards -> RemoveAll();
        delete tmpGamer;
        aCards -> AtPut(j,tmpSecondCardOut);
      }
    }
    aCards -> AtPut(i,tmpFirstCardOut);
  }

  RealFirstCardOut     = aCards -> MaxCard(FirstCardOut->CMast);
  aCards -> Remove(RealFirstCardOut);
  aOut -> Insert(RealFirstCardOut);
  if (SecondCardOut->CMast != FirstCardOut->CMast) {
		RealSecondCardOut = aCards -> MaxCard(SecondCardOut->CMast);
   } else {
		RealSecondCardOut = aCards -> MoreThan(FirstCardOut);
		if ( !RealSecondCardOut )
			RealSecondCardOut = aCards -> MaxCard(); // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!1 Bad algoritm
   }
  aCards -> Remove(RealSecondCardOut);
  aOut -> Insert(RealSecondCardOut);
  aCards -> mySort();
	return g86;
}
//-----------------------------------------------------------------------
TGamesType TGamer::makeout4game(void) {
  TCard *FirstCardOut=NULL,*SecondCardOut=NULL;
  TCard *tmpFirstCardOut,*tmpSecondCardOut;
  TCard *RealFirstCardOut,*RealSecondCardOut;
  TGamesType  Hight = zerogame,  tmpHight = zerogame;
  for ( int i=0;i<12;i++ ) {
    tmpFirstCardOut = (TCard*) aCards -> At(i);
    aCards -> AtRemove(i);
    for ( int j=0;j<12;j++ )  {
      if ( j!=i ) {
        tmpSecondCardOut = (TCard*) aCards -> At(j);
        aCards -> AtRemove(j);
        TGamer *tmpGamer = new TGamer(99);
        tmpGamer -> aCards -> Assign(aCards);
        tmpGamer -> aCards -> mySort();
        tmpHight = tmpGamer -> makemove4out();
        if ( (tmpHight > Hight )
         || (tmpHight == Hight  && tmpGamer->MastTable[0].perehvatov < MastTable[0].perehvatov) ) {
          Hight = tmpHight;
          FirstCardOut = tmpFirstCardOut;
          SecondCardOut = tmpSecondCardOut;
        }
        tmpGamer -> aCards -> RemoveAll();
        delete tmpGamer;
        aCards -> AtPut(j,tmpSecondCardOut);
      }
    }
    aCards -> AtPut(i,tmpFirstCardOut);
  }

  RealFirstCardOut     = aCards -> MinCard(FirstCardOut->CMast);
  aCards -> Remove(RealFirstCardOut);
  aOut -> Insert(RealFirstCardOut);
  if (SecondCardOut->CMast != FirstCardOut->CMast) {
		RealSecondCardOut = aCards -> MinCard(SecondCardOut->CMast);
   } else {
		RealSecondCardOut = aCards -> MoreThan(FirstCardOut);
		if ( !RealSecondCardOut )
			RealSecondCardOut = aCards -> MinCard(); // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!1 Bad algoritm
   }
  aCards -> Remove(RealSecondCardOut);
  aOut -> Insert(RealSecondCardOut);
  aCards -> mySort();
//  Hight = makemove(undefined,undefined);
  Hight =  makemove4out();
  if ( Hight < GamesType )  {
    /*    */
    int tmpvz = Hight/10,tmpmast = Hight - tmpvz*10;
    while ( tmpHight < GamesType )  {
      tmpvz++;
      tmpHight = (TGamesType) (tmpvz*10+tmpmast);
    }
    GamesType = tmpHight;
  } else {
    GamesType = Hight;
  }
  return GamesType;
}
//-----------------------------------------------------------------------
TGamesType TGamer::makemove(TGamesType lMove,TGamesType rMove) { //  
  if ( GamesType != pass )  {
    int i;
    int nMaxMastLen=0;
    TMast nMaxMast=withoutmast;
    TMastTable LocalMastTable[5];
    TGamesType MGT = max(lMove,rMove);
    LocalMastTable[0].vzatok=0;
    LocalMastTable[0].perehvatov=0;
    LocalMastTable[0].sum = 0;
    for (i=1; i<=4; i++ )  {
      LocalMastTable[i] = vzatok4game( (TMast) i,1  );
      LocalMastTable[0].vzatok += LocalMastTable[i].vzatok ;
      LocalMastTable[0].perehvatov +=LocalMastTable[i].perehvatov ;
      LocalMastTable[0].sum += LocalMastTable[i].sum;
    }
    for (i=1; i<=4; i++) { //   -   
      if( aCards->AllCard(i) > nMaxMastLen ) {
        nMaxMastLen = aCards->AllCard(i);
        nMaxMast = (TMast) i;
      }
    }
    for (i=1; i<=4; i++) {
      if(aCards->AllCard(i) == nMaxMastLen && nMaxMast != i ) { //    
       if ( LocalMastTable[i].sum  > LocalMastTable[nMaxMast].sum  )  {
         nMaxMast = (TMast) i;
        }
      }
    }
    //    
    if (MGT <= g75) {
	    GamesType = ( TGamesType ) ((LocalMastTable[0].vzatok+1)*10 + nMaxMast );
	  } else {
		  GamesType = ( TGamesType ) ((LocalMastTable[0].vzatok)*10 + nMaxMast );
	  }
		if ( (rMove==pass || rMove==undefined) && ( lMove==pass || lMove==undefined ) ) {
			if ( LocalMastTable[0].vzatok >= 4 ) {
				GamesType = g61;
			} else {
				if ( LocalMastTable[0].vzatok == 0 )  {
           // check for miser !!!
					if (Check4Miser()) {
						GamesType = g86;
					} else {
						GamesType = pass;
					}
				} else {
					GamesType = pass;
				}
			}
		} else if(GamesType >= MGT) {
	  		GamesType = (TGamesType) NextGame(MGT);
		} else {
			GamesType = pass;
		}
	}
  return GamesType;
}
//-----------------------------------------------------------------------
int TGamer::Check4Miser( void) {
	int RetVal = 0;
	for (int Mast = pica;Mast<=cherva;Mast++) {	
		if ( aCards -> Exist(7,Mast) && ( aCards -> Exist(9,Mast) || aCards -> Exist(8,Mast) ) && ( aCards -> Exist(J,Mast) || aCards -> Exist(10,Mast) )    ){
				RetVal++;
		}
	}
	if (RetVal==4)	return 1;
	return 0;
}
//-----------------------------------------------------------------------
TMastTable TGamer::vzatok4game(TMast Mast, int a23) {
   TMastTable MastTable;
   TCard *MyCard,*tmpCard;
   TCardList *MyCardStack     = new TCardList(MAXMASTLEN);
   TCardList *EnemyCardStack  = new TCardList(MAXMASTLEN);
   for (int c=7;c<=A;c++ ) {
    MyCard = aCards->Exist(c, Mast);
    if ( MyCard )
      MyCardStack->Insert(MyCard);
    else
      EnemyCardStack->Insert(new TCard(c, Mast));
   }
   if ( MyCardStack->AllCard() >=4 && MyCardStack->AllCard() <=5 )    {
      EnemyCardStack -> Free(EnemyCardStack ->MinCard());
   }
   if ( a23 == 23 ) {
       MastTable = Compare2List4Max23(MyCardStack,EnemyCardStack);
   } else {
       MastTable = Compare2List4Max(MyCardStack,EnemyCardStack);
   }
   MastTable.len = aCards->AllCard(Mast);
   MastTable.sum = 0;
   for (int j=7;j<=A;j++ ) {
    tmpCard = aCards->Exist(j,Mast);
    if (  tmpCard ) {
      MastTable.sum +=  tmpCard -> CName;
    }
   }
   MyCardStack -> RemoveAll();
   delete MyCardStack;
   delete EnemyCardStack;
   return MastTable;
}
//-----------------------------------------------------------------------
TMastTable TGamer::vzatok4pass(TMast Mast,TCardList *aMaxCardList) {
   TMastTable MastTable;
   TCard *MyCard,*tmpCard;
   TCardList *MyCardStack     = new TCardList(MAXMASTLEN);
   TCardList *EnemyCardStack  = new TCardList(MAXMASTLEN);
   for (int c=7;c<=A;c++ ) {
        MyCard = aCards->Exist(c, Mast);
        if ( MyCard ) {
          MyCardStack->Insert(MyCard);
        }
        MyCard = aMaxCardList->Exist(c, Mast);
        if ( MyCard ) {
          EnemyCardStack->Insert(MyCard);
        }
   }
   MastTable = Compare2List4Min(MyCardStack,EnemyCardStack);
   MastTable.len = aCards->AllCard(Mast);
   MastTable.sum = 0;
   for (int j=7;j<=A;j++ ) {
    tmpCard = aCards->Exist(j,Mast);
    if (  tmpCard ) {
      MastTable.sum +=  tmpCard -> CName;
    }
   }
   MyCardStack -> RemoveAll();
   EnemyCardStack-> RemoveAll();
   delete MyCardStack;
   delete EnemyCardStack;
   return MastTable;

}

//-----------------------------------------------------------------------
TMastTable TGamer::Compare2List4Min(TCardList *My,TCardList *Enemy) { //   
  TMastTable MastTable;
  MastTable.vzatok=0;
  MastTable.perehvatov=0;
  int nMaxLen;
  TCard *MyCardMin,*EnemyCardMax,*EnemyCardMin;
  // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//  Enemy->Free(Enemy->MinCard());
  My->AllCard()>Enemy->AllCard() ? nMaxLen = My->AllCard() : nMaxLen = Enemy->AllCard();
  for ( int i=1; i<=nMaxLen; i++ )  {
    MyCardMin = My->MinCard();
    EnemyCardMax = Enemy->MaxCard();
    if ( MyCardMin ) {
      EnemyCardMin = Enemy->LessThan(MyCardMin);
      if (!EnemyCardMin) {
          EnemyCardMin = Enemy->MinCard();
      }

    } else {
//      EnemyCardMin = Enemy->MinCard();
      break;
    }
    if ( !EnemyCardMax && !EnemyCardMin)  {
      break;
    }
    if ( *MyCardMin > *EnemyCardMin ) {
      //     
      My -> Remove(MyCardMin);
//      Enemy -> Free(EnemyCardMin);
      Enemy -> Remove(EnemyCardMin);

      MastTable.vzatok++;
    } else {
      My -> Remove(MyCardMin);
//      Enemy -> Free(EnemyCardMax);
      Enemy -> Remove(EnemyCardMax);
    }
  }
  return MastTable;
}
//-----------------------------------------------------------------------
TMastTable TGamer::Compare2List4Max(TCardList *My,TCardList *Enemy) {
  TMastTable MastTable;
  MastTable.vzatok=0;

  MastTable.perehvatov=0;
  int nMaxLen,nIget=1;
  TCard *MyCardMax,*EnemyCardMax,*EnemyCardMin;
  My->AllCard()>Enemy->AllCard() ? nMaxLen = My->AllCard() : nMaxLen = Enemy->AllCard();
  for ( int i=1; i<=nMaxLen; i++ )  {
    MyCardMax = My->MaxCard();
    if ( MyCardMax ) {
      EnemyCardMax = Enemy->MoreThan(MyCardMax);
      if (!EnemyCardMax) {
        EnemyCardMax = Enemy->MinCard();
      }
    } else {
      EnemyCardMax = Enemy->MaxCard();
    }
    EnemyCardMin = Enemy->MinCard();
    if ( !MyCardMax )  {
      break;
    }
    if ( !EnemyCardMax && !EnemyCardMin)  {
      //  -  
      for ( int j =1; j<=My->AllCard();j++ ) {
        MastTable.vzatok++;
      }
      break;
    }
    if ( *MyCardMax > *EnemyCardMax ) {
      //   ,  
      My -> Remove(MyCardMax);
//      Enemy -> Free(EnemyCardMin);
	Enemy -> Remove(EnemyCardMin);
      MastTable.vzatok++;
      if ( !nIget )  {
        MastTable.perehvatov++;
      }

      nIget = 1;
    } else {
      My -> Remove(MyCardMax);
//      Enemy -> Free(EnemyCardMax);
      Enemy -> Remove(EnemyCardMax);
      nIget = 0;
    }
  }
  return MastTable;
}
//-----------------------------------------------------------------------
TMastTable TGamer::Compare2List4Max23(TCardList *My,TCardList *Enemy) {
  TMastTable MastTable;
  MastTable.vzatok=0;
  MastTable.perehvatov=0;
  int nMaxLen,nIget=1;
  TCard *MyCardMax,*EnemyCardMax; //,*EnemyCardMin;
  My->AllCard()>Enemy->AllCard() ? nMaxLen = My->AllCard() : nMaxLen = Enemy->AllCard();
  for ( int i=1; i<=nMaxLen; i++ )  {
		EnemyCardMax = Enemy->MaxCard();
		if (EnemyCardMax) { //  -  m  
			MyCardMax = My -> MoreThan(EnemyCardMax);
			if ( ! MyCardMax ) {	//       
				MyCardMax = My -> MinCard();
				if (!MyCardMax ) {	//    
					break ;
				} else {	//    
					My -> Remove(MyCardMax);
					Enemy -> Remove(EnemyCardMax);
					nIget = 0;
				}
			} else {	//     
				My -> Remove(MyCardMax);
				Enemy -> Remove(EnemyCardMax);
				MastTable.vzatok++;
				if (! nIget) MastTable.perehvatov++;
				nIget = 1;
			}
		} else {	//        !  -  
			if ( ! Enemy->AllCard() ) {
				for ( int j =1; j<=My->AllCard();j++ ) MastTable.vzatok++;
			}
//25.07.2000 for ( int j =1; j<=My->AllCard();j++ ) MastTable.vzatok++;
      break;
		}
  }
  return MastTable;
}
//-----------------------------------------------------------------------
TCard *TGamer::MyPass1(TCard *rMove,TGamer *aLeftGamer,TGamer *aRightGamer) {
  TCard *RetVal=NULL;
  TGamesType tmpGamesType=GamesType;
  TCardList *aMaxCardList=new TCardList(20);
  TCardList *aTmpList=new TCardList(MAXMASTLEN);
  TCardList *aStackStore=NULL;

  if ( rMove != NULL )  {
    aTmpList=new TCardList(MAXMASTLEN);
    aTmpList -> AssignMast(aCards,(TMast)rMove->CMast);
    aStackStore = aCards;
    aCards = aTmpList;
//    LoadLists(aLeftGamer,aRightGamer,aMaxCardList); // !!!!!!!!!
//    RecountTables4RasPass(aMaxCardList,1);
  }
  if ( tmpGamesType == raspass || tmpGamesType == g86 )  { //  // 
    LoadLists(aLeftGamer,aRightGamer,aMaxCardList); // !!!!!!!!!
    RecountTables4RasPass(aMaxCardList,1);
     //   : 100 %  χ,    -     
    RetVal = GetMaxCardWithOutPere(); //        
    if ( RetVal ) {
        if ( aLeftGamer->aCards->AllCard(RetVal->CMast)==0
             && aRightGamer->aCards->AllCard(RetVal->CMast)==0 ) {

          RetVal = NULL;
        }
    }
    if ( !RetVal ) {
         RetVal = GetMaxCardPere();  //   (max)
    }
    if ( !RetVal ) {
       RetVal = GetMinCardWithOutVz(); 	// 
    }
    if ( !RetVal ) {
        RetVal = aCards->MinCard();
    }
  }
  if ( rMove != NULL )  {
    aCards=aStackStore;
    aTmpList -> RemoveAll();
    delete aTmpList;

  }


  GamesType=tmpGamesType;
  delete aMaxCardList;
  return RetVal;
}
//-----------------------------------------------------------------------
TCard *TGamer::MyPass2(TCard *aRightCard,TGamer *aLeftGamer,TGamer *aRightGamer) {
  TCard *RetVal=NULL;
  TGamesType tmpGamesType=GamesType;
  int mast = aRightCard -> CMast;
  TCardList *aMaxCardList=new TCardList(20);
  LoadLists(aLeftGamer,aRightGamer,aMaxCardList);
  RecountTables4RasPass(aMaxCardList,1);
/////////////////////////////////////////////////////////
  if ( tmpGamesType == raspass || tmpGamesType == g86 )  { //  // 
    RetVal = aCards -> MaxCard(mast); // !!!!!!!!!!!!  
    if ( !RetVal ) { //  
      //   !!!        100 % 
       RetVal = GetMaxCardWithOutPere();
       if ( !RetVal ) {
               RetVal = GetMaxCardPere();  //   (max)
       }
       if ( !RetVal ) {
             RetVal = GetMinCardWithOutVz(); // 
       }
       if ( !RetVal ) {
              RetVal = aCards->MinCard();
       }

    } else { //    
        if ( aLeftGamer -> aCards -> AllCard(mast) ) { //   
            RetVal = aCards -> LessThan(aLeftGamer -> aCards ->MaxCard(mast));
            if ( !RetVal ) {
                RetVal = aCards -> MaxCard(mast);
            }
        } else { //   
           RetVal = aCards -> LessThan(aRightCard);
           if ( !RetVal) {
               RetVal = aCards -> MaxCard(mast);
           }
        }
    }
  }
/////////////////////////////////////////////////////////
  delete aMaxCardList;
  GamesType=tmpGamesType;
  return RetVal;
}
//-----------------------------------------------------------------------
TCard *TGamer::MyPass3(TCard *aLeftCard,TCard *aRightCard,TGamer *aLeftGamer,TGamer *aRightGamer) {
  TCard *RetVal=NULL;
    /*TCard *MaxCard;*/
    TGamesType tmpGamesType=GamesType;
    TCardList *aMaxCardList=new TCardList(20);
//    int mast = GamesType - (GamesType/10) * 10;
    //  
    LoadLists(aLeftGamer,aRightGamer,aMaxCardList);
    RecountTables4RasPass(aMaxCardList,23);
    if ( aCards->AllCard(aLeftCard->CMast) )  {
       //         
       // c 
       if (aLeftCard->CMast == aRightCard ->CMast) {
       	if (*aRightCard > *aLeftCard) {
       		RetVal = aCards -> LessThan(aRightCard);      		
       	} else {
       		RetVal = aCards -> LessThan(aLeftCard);
       	}
       } else {
	       RetVal = aCards -> LessThan(aLeftCard);
	     }
       if ( !RetVal  ) {
           RetVal = aCards ->MaxCard(aLeftCard->CMast);
       }
    } else {
      //         
       RetVal = GetMaxCardWithOutPere();
       if ( !RetVal ) {
               RetVal = GetMaxCardPere();  //    (max)
       }
       if ( !RetVal ) {
             RetVal = GetMinCardWithOutVz(); // 
       }
       if ( !RetVal ) {
              RetVal = aCards->MinCard();
       }

    }
    GamesType=tmpGamesType;
    delete aMaxCardList;

  return RetVal;
}
//-----------------------------------------------------------------------
void TGamer::makestatfill(void) {
   TSide lr=left;
   for (int m=1;m<=4;m++) {
     for (int c=A;c>=7;c-- ) {
      if ( !aCards->Exist(c,m) ) {
         if (lr==left) {
           aLeft->Insert(new TCard(c,m));
           lr = right;
         } else {
           aRight->Insert(new TCard(c,m));
           lr = left;
         }
       }
     }
   }
}
//-----------------------------------------------------------------------
void TGamer::makestatfill(int nCards,int maxmin) {
    int nCounter=0;
    TSide lr=left;
    if ( maxmin ==1 ) {
       for (int m=1;m<=4;m++) {
         for (int c=A;c>=7;c-- ) {
          if ( !aCards->Exist(c,m) && !aOut->Exist(c,m) ) {
             if (lr==left) {
               aLeft->Insert(new TCard(c,m));
               lr = right;
             } else {
               aRight->Insert(new TCard(c,m));
               lr = left;
               nCounter++;
               if ( nCounter >= nCards ) return;
             }
           }
         }
       }
    } else {
       for (int m=1;m<=4;m++) {
         for (int c=7;c<=A;c++ ) {
          if ( !aCards->Exist(c,m) && !aOut->Exist(c,m) ) {
             if (lr==left) {
               aLeft->Insert(new TCard(c,m));
               lr = right;
             } else {
               aRight->Insert(new TCard(c,m));
               lr = left;
               nCounter++;
               if ( nCounter >= nCards ) return;
             }
           }
         }
       }
    }
}


//--------------------------------------------------------------
void TGamer::HintCard(int ,int ) {
}
//--------------------------------------------------------------
void TGamer::GetBackSnos(void) {

	// Vernut snos
	if (aCardsOut->At(0))
		aCards->Insert(aCardsOut->At(0));
	if (aCardsOut->At(1))
		aCards->Insert(aCardsOut->At(1));	
	aCardsOut -> RemoveAll();
}
