#include <string.h>
#include <stdio.h>

#include "prfconst.h"
#include "card.h"


//--------------------------------------------------------------------------
typedef struct {
 TGamesType GamesType;
 const char *name;
}  TGameName;
//--------------------------------------------------------------------------
TGameName GameName[] = {
  {g86catch," "},
  {raspass,"Pas"},
  {undefined,"-----"},
  {vist,"Vist"},
  {pass,"Pas"},
  {g61,"6 pik"},
  {g62,"6 tref"},
  {g63,"6 buben"},
  {g64,"6 chervey"},
  {g65,"6 BK"},
  {g71,"7 pik"},
  {g72,"7 tref"},
  {g73,"7 buben"},
  {g74,"7 chervey"},
  {g75,"7 BK"},
  {g81,"8 pik"},
  {g82,"8 tref"},
  {g83,"8 buben"},
  {g84,"8 chervey"},
  {g85,"8 BK"},
  {g86,"Miser"},
  {g91,"9 pik"},
  {g92,"9 tref"},
  {g93,"9 buben"},
  {g94,"9 chervey"},
  {g95,"9 BK"},
  {g101,"10 pik"},
  {g102,"10 tref"},
  {g103,"10 buben"},
  {g104,"10 chervey"},
  {g105,"10 BK"}
};
//--------------------------------------------------------------------------
int g61stalingrad;
int g10vist;
int globvist;
int nBuletScore;
TGamesType CurrentGame;

//--------------------------------------------------------------------------
int nGetKoz(void) {
	return CurrentGame - (CurrentGame/10) * 10;
}
//--------------------------------------------------------------------------
int NextGame(TGamesType GamesType) {

  if ( GamesType == g86 )  {
    return g91;
  }
  if (GamesType == g105 )  {
    return GamesType;
  }
  if (GamesType == pass )  {
  		return g61;
  }
  if ( GamesType != undefined )  {
    int vz = GamesType/10,mast = GamesType - vz*10;
    if ( mast != 5 ) {
      mast++;

    } else {
      mast = pica;
      vz ++;
    }
    return vz*10+mast;
  } else {
  		return g61;
  }
  return pass;
}
//--------------------------------------------------------------------------

char *sGameName(TGamesType GamesType) {
   for (unsigned int i=0;i<=sizeof(GameName)/sizeof(TGameName);i++) {
      if (GameName[i].GamesType == GamesType) return (char *) GameName[i].name;
   }
   return "                 ";
}
//--------------------------------------------------------------------------
int nGetGameCard(TGamesType gType) {
   if ( gType >=g71 && gType <= 75)   return 7;
   if ( gType >=g81 && gType <= 85)   return 8;
   if ( gType ==g86)                  return 0;
   if ( gType >=g91 && gType <= 95)   return 9;
   if ( gType >=g101 && gType <= 105) return 10;
   return 6;
}
//--------------------------------------------------------------------------
int nGetVistCard(TGamesType gType) {
   if ( gType >=g71 && gType <= 75)   return 2;
   if ( gType >=g81 && gType <= 85)   return 1;
   if ( gType ==g86)                  return 0;
   if ( gType >=g91 && gType <= 95)   return 1;
   if ( gType >=g101 && gType <= 105) return 1;
   return 4;
}
//--------------------------------------------------------------------------
int nGetMinCard4Vist(TGamesType gType) {
   if ( gType >=g71 && gType <= 75)   return 2;
   if ( gType >=g81 && gType <= 85)   return 1;

   if ( gType ==g86)                  return 0;
   if ( gType >=g91 && gType <= 95)   return 1;
   if ( gType >=g101 && gType <= 105) return 0;
   return 3;
}
//--------------------------------------------------------------------------
int nGetGamePrice(TGamesType gType) {
   if ( gType >=g71 && gType <= 75)    return 4;
   if ( gType >=g81 && gType <= 85)    return 6;
   if ( gType ==g86)                   return 10;
   if ( gType >=g91 && gType <= 95)    return 8;
   if ( gType >=g101 && gType <= 105)  return 10;
   return 2;
}
//----------------------------------------------------------------------
TGamesType GamesTypeByName(char *sname) {
  if ( !strcmp("raspass",sname)) return   raspass;
  if ( !strcmp("vist",sname)) return          vist;
  if ( !strcmp("undefined",sname)) return     undefined;
  if ( !strcmp("pass",sname)) return          pass;
  if ( !strcmp("g61",sname)) return           g61;
  if ( !strcmp("g62",sname)) return           g62;
  if ( !strcmp("g63",sname)) return           g63;
  if ( !strcmp("g64",sname)) return           g64;
  if ( !strcmp("g65",sname)) return           g65;
  if ( !strcmp("g71",sname)) return           g71;
  if ( !strcmp("g72",sname)) return           g72;
  if ( !strcmp("g73",sname)) return           g73;
  if ( !strcmp("g74",sname)) return           g74;
  if ( !strcmp("g75",sname)) return           g75;
  if ( !strcmp("g81",sname)) return           g81;

  if ( !strcmp("g82",sname)) return           g82;
  if ( !strcmp("g83",sname)) return           g83;
  if ( !strcmp("g84",sname)) return           g84;
  if ( !strcmp("g85",sname)) return           g85;
  if ( !strcmp("g86",sname)) return           g86;
  if ( !strcmp("g91",sname)) return           g91;
  if ( !strcmp("g92",sname)) return           g92;
  if ( !strcmp("g93",sname)) return           g93;
  if ( !strcmp("g94",sname)) return           g94;
  if ( !strcmp("g95",sname)) return           g95;
  if ( !strcmp("g101",sname)) return          g101;
  if ( !strcmp("g102",sname)) return          g102;
  if ( !strcmp("g103",sname)) return          g103;
  if ( !strcmp("g104",sname)) return          g104;
  if ( !strcmp("g105",sname)) return          g105;
  return     undefined;
}
//----------------------------------------------------------------------
int Card2Int(void *vCard) {
        TCard *Card = (TCard*) vCard;
        if (Card)
                return Card -> CName*10 + Card -> CMast;
        return -1;
}
//----------------------------------------------------------------------

// ------- feal 3.10.2003 ----------------
char *CardName(void *vCard, char *CName) {
	TCard *Card = (TCard*) vCard;
	char tempp[10];

	if (Card){
		if(Card->CName == 7) strcpy(tempp, "7");
		else if(Card->CName == 8) strcpy(tempp, "8");
		else if(Card->CName == 9) strcpy(tempp, "9");
		else if(Card->CName == 10) strcpy(tempp, "10");
		else if(Card->CName == 11) strcpy(tempp, "Valet");
		else if(Card->CName == 12) strcpy(tempp, "Dama");
		else if(Card->CName == 13) strcpy(tempp, "Korol");
		else if(Card->CName == 14) strcpy(tempp, "Tuz");

		if(Card->CMast == 1)       sprintf(CName, "%s pik", tempp);
		else if(Card->CMast == 2)  sprintf(CName, "%s tref", tempp);
		else if(Card->CMast == 3)  sprintf(CName, "%s buben", tempp);
		else if(Card->CMast == 4)  sprintf(CName, "%s chervey", tempp);
		
		return CName;
	}
	return NULL;
}
// -------------------------------------------

